con
  _CLKMODE      = XTAL1 + PLL8X                        
  _XINFREQ      = 10_000_000

  ' Chip select pin / bitmask
  CS_     = 18
  CS_pin  = 1<<18
  ' Register select
  RS_     = 9
  RS_pin  = 1<<9
  ' Write      
  WR_     = 17
  WR_pin  = 1<<17
  ' Read
  RD_     = 15
  RD_pin  = 1<<15
  ' Reset
  RES_    = 16
  RES_PIN = 1<<16

obj
  lcd: "SPFD5408driver"

var
 long route
  
pub main | ferb
  ' TestPin( 21 )
  lcd.start( RS_, CS_, RD_, WR_, RES_, 0 )
  route:=7

  Init

  'lcd.start( RS_, CS_, RD_, WR_, RES_, 16 )
  'dira:=0
  'route:=7
  'repeat 

  'Home
  ' cmd( $22 )
  ferb:=0
  repeat 100
    ' waitcnt( clkfreq/2 +cnt)
    Home
    lcd.exec( lcd#CMD_CLEAR, ferb )
    'set_rgb( ferb )
    ferb:=(ferb+$2f1a0c)&$ffffff

  repeat 

' Function for testing the connection. It outputs a squarewave signal on the pin.
pub TestPin( pinNo )
  dira:=1<<pinNo
  repeat
    outa[pinNo]~
    outa[pinNo]~~
    
pub Home
  ' write_command( 0x0020); // GRAM Address Set (Horizontal Address) (R20h)
  cmd( $20 )
  ' write_data( 0x0000);
  data( 0 )
  ' write_command( 0x0021); // GRAM Address Set (Vertical Address) (R21h)
  cmd( $21 )
  ' write_data( 0x0000);
  data( 0 )
  ' write_command(0x0022);  // Write Data to GRAM (R22h)
  cmd( $22 )

pub set_rgb( col ) | i, j, r, g, b
  Home

  ' for(i=0;i<500;i++)
  repeat i from 0 to 320
    ' for(j=0;j<500;j++)
    repeat j from 0 to 239
      ' write_data(data);
      ' cmd( )
      r:=(i+col>>16) & $ff
      g:=(j+col>>8) & $ff
      b:=((255-r+255-g+ col)& $1ff)>>1
      pixel( g<<16+r<<8+b )
    
pri cmd( command ) | col
  if route&$1
    lcd.exec( lcd#CMD_CMDOUT, command )
    'waitcnt( clkfreq/1000 +cnt )
  else
    outa[ RS_ ]:=0
    outa[ 23..16 ]:=(command>>8)
    outa[ WR_ ]:=0
    outa[ WR_ ]:=1
    outa[ 23..16 ]:=command
    outa[ WR_ ]:=0
    outa[ WR_ ]:=1

pri data( val ) | col
  if route&$2
    lcd.exec( lcd#CMD_DATAOUT, val )
    'waitcnt( clkfreq/1000 +cnt )
  else
    outa[ RS_ ]:=1
    outa[ 23..16 ]:=(val>>8)
    outa[ WR_ ]:=0
    outa[ WR_ ]:=1
    outa[ 23..16 ]:=val
    outa[ WR_ ]:=0
    outa[ WR_ ]:=1

pri pixel( col )
  if route & 4
    lcd.exec( lcd#CMD_PIXELOUT, col )
    'waitcnt( clkfreq/1000 +cnt )
  else
    outa[ RS_ ]:=1
    outa[ 23..16 ]:=(col>>16)
    outa[ WR_ ]:=0
    outa[ WR_ ]:=1
    outa[ 23..16 ]:=(col>>8)
    outa[ WR_ ]:=0
    outa[ WR_ ]:=1
    outa[ 23..16 ]:=col
    outa[ WR_ ]:=0
    outa[ WR_ ]:=1

pub Init | col
  if route==0
    outa := CS_pin | RD_pin | WR_pin | RES_pin
    dira := CS_pin | RS_pin | WR_pin | RD_pin | RES_pin | $00ff0000

    outa[ RD_ ]:=1
    outa[ WR_ ]:=1
    outa[ CS_ ]:=1
    outa[ RS_ ]:=1
    outa[ 23..16 ]:=0

    outa[ RES_ ]:=0
    waitcnt( clkfreq/50 + cnt )
    outa[ RES_ ]:=1
    waitcnt(clkfreq/20 + cnt)

    outa[ CS_ ]:=0

  cmd( $00 )
  data( $0001 )
  ' write_command(0x0001)     ' Driver Output Control Register (R01h)
  cmd( $01 )
  ' write_data(0x0000)      ' Page 14, SPFD5408B Datasheet
  data( 0 )

  ' write_command(0x0002)     ' LCD Driving Waveform Control (R02h)
  cmd( $02 )
  ' write_data(0x0700)      ' Page 15, SPFD5408B Datasheet
  data( $0701 )
   
  ' write_command(0x0003)     ' Entry Mode (R03h)
  cmd( $03 )
  ' write_data(0x50A0)      ' Page 15, SPFD5408B Datasheet
  data( $D010 )

  ' write_command(0x0004)     ' Scaling Control register (R04h)
  cmd( $04 )
  ' write_data(0x0000)      ' Page 16, SPFD5408B Datasheet
  data( 0 )

  ' write_command(0x0008)     ' Display Control 2 (R08h)
  cmd( $08 )
  ' write_data(0x0207)      ' Page 17, SPFD5408B Datasheet
  data( $0207 )

  ' write_command(0x0009)     ' Display Control 3 (R09h)
  cmd( $09 )
  ' write_data(0x0000)      ' Page 18, SPFD5408B Datasheet
  data( 0 )

  ' write_command(0x000A)     ' Frame Cycle Control (R0Ah)
  cmd( $0a )
  ' write_data(0x0000)      ' Page 19, SPFD5408B Datasheet
  data( 0 )

  ' write_command(0x000C)     ' External Display Interface Control 1 (R0Ch)
  cmd( $0c )
  ' write_data(0x0000)      ' Page 20, SPFD5408B Datasheet
  data( 0 )

  ' write_command(0x000D)     ' Frame Maker Position (R0Dh)
  cmd( $0d )
  ' write_data(0x0000)      ' Page 21, SPFD5408B Datasheet
  data( 0 )

  ' write_command(0x000F)     ' External Display Interface Control 2 (R0Fh)
  cmd( $0f )
  ' write_data(0x0000)      ' Page 21, SPFD5408B Datasheet
  data( 0 )

  cmd( $07 )
  data( $0101 )

  ' write_command(0x0010)     ' Power Control 1 (R10h)
  cmd( $10 )
  ' write_data(0x0000)      ' Page 22, SPFD5408B Datasheet
  data( $10B0 )

  ' write_command(0x0011)     ' Power Control 2 (R11h)
  cmd( $11 )
  ' write_data(0x0007)      ' Page 23, SPFD5408B Datasheet
  data( $0007 )

  cmd( $07 )
  data( $0001 )

  ' write_command(0x0012)     ' Power Control 3 (R12h)
  cmd( $12 )
  ' write_data(0x0000)      ' Page 24, SPFD5408B Datasheet
  data( $013B )

  ' write_command(0x0013)     ' Power Control 4 (R13h)
  cmd( $13 )
  ' write_data(0x0000)      ' Page 25, SPFD5408B Datasheet
  data( $0B00 )
  ' delay(200);      

  waitcnt( clkfreq/5 +cnt )


  ' write_command(0x0029)     ' NVM read data 2 (R29h)
  cmd( $29 )
  ' write_data(0x0010)      ' Page 30, SPFD5408B Datasheet 
  data( $0012 )
  ' delay(50);
  cmd( $2A )
  data( $0095 )

  waitcnt( clkfreq/50 + cnt )

  ' write_command(0x0030)     ' Gamma Control 1
  cmd( $30 )
  ' write_data(0x000A)      ' Page 32, SPFD5408B Datasheet
  data( $000a ) 
  cmd($31)     ' Gamma Control 2
  data($1326)      ' Page 32, SPFD5408B Datasheet  
  cmd($0032)     ' Gamma Control 3
  data($0A29)      ' Page 32, SPFD5408B Datasheet  
  cmd($0033)     ' Gamma Control 4
  data($290A)      ' Page 32, SPFD5408B Datasheet  
  cmd($0034)     ' Gamma Control 5
  data($2613)      ' Page 32, SPFD5408B Datasheet  
  cmd($0035)     ' Gamma Control 6
  data($0A0A)      ' Page 32, SPFD5408B Datasheet  
  cmd($0036)     ' Gamma Control 7
  data($1E03)      ' Page 32, SPFD5408B Datasheet  
  cmd($0037)     ' Gamma Control 8
  data($031E)      ' Page 32, SPFD5408B Datasheet 
  cmd($0038)     ' Gamma Control 9
  data($0706)      ' Page 32, SPFD5408B Datasheet  
  cmd($0039)     ' Gamma Control 10
  data($0303)      ' Page 32, SPFD5408B Datasheet  
  cmd($003A)     ' Gamma Control 11
  data($0E04)      ' Page 32, SPFD5408B Datasheet  
  cmd($003B)     ' Gamma Control 12
  data($0E01)      ' Page 32, SPFD5408B Datasheet  
  cmd($003C)     ' Gamma Control 13
  data($010E)      ' Page 32, SPFD5408B Datasheet  
  cmd($003D)     ' Gamma Control 14
  data($040E)      ' Page 32, SPFD5408B Datasheet  
  cmd($003E)     ' Gamma Control 15
  data($0303)      ' Page 32, SPFD5408B Datasheet  
  cmd($003F)     ' Gamma Control 16
  data($0607)      ' Page 32, SPFD5408B Datasheet  

  ' the data calls that are commented out came from demo-code, the actual
  ' calls use parameters as given in init-sequence of datasheet
  cmd($0050)     ' Window Horizontal RAM Address Start (R50h)
  data($0000)      ' Page 32, SPFD5408B Datasheet
  'data($0030)      ' Page 32, SPFD5408B Datasheet
  cmd($0051)     ' Window Horizontal RAM Address End (R51h)
  data($00EF)      ' Page 32, SPFD5408B Datasheet
  'data($0080)      ' Page 32, SPFD5408B Datasheet
  cmd($0052)     ' Window Vertical RAM Address Start (R52h)
  data($0000)      ' Page 33, SPFD5408B Datasheet
  'data($0050)      ' Page 33, SPFD5408B Datasheet
  cmd($0053)     ' Window Vertical RAM Address End (R53h)
  data($013F)      ' Page 33, SPFD5408B Datasheet
  'data($0100)      ' Page 33, SPFD5408B Datasheet

  cmd($0060)     ' Driver Output Control (R60h)
  data($2700)      ' Page 33, SPFD5408B Datasheet
  cmd($0061)     ' Driver Output Control (R61h)
  data($0001)      ' Page 35, SPFD5408B Datasheet

  cmd($006A)     ' Vertical Scroll Control (R6Ah)
  data($0000)      ' Page 35, SPFD5408B Datasheet

  cmd($0080)     ' Display Position - Partial Display 1 (R80h)
  data($0000)      ' Page 35, SPFD5408B Datasheet
  cmd($0081)     ' RAM Address Start - Partial Display 1 (R81h)
  data($0000)      ' Page 35, SPFD5408B Datasheet
  'data($0021)
  cmd($0082)     ' RAM Address End - Partial Display 1 (R82h)
  data($0000)      ' Page 36, SPFD5408B Datasheet
  'data($0061)
  cmd($0083)     ' Display Position - Partial Display 2 (R83h)
  data($0000)      ' Page 36, SPFD5408B Datasheet 
  'data($0173)
  cmd($0084)     ' RAM Address Start - Partial Display 2 (R84h)
  data($0000)      ' Page 36, SPFD5408B Datasheet 
  cmd($0085)     ' RAM Address End - Partial Display 2 (R85h)
  data($0000)      ' Page 36, SPFD5408B Datasheet 

  cmd($0090)     ' Panel Interface Control 1 (R90h)
  'data($0010)      ' Page 36, SPFD5408B Datasheet 
  data($0013)
  cmd($0092)     ' Panel Interface Control 2 (R92h)
  data($0000)      ' Page 37, SPFD5408B Datasheet 
  cmd($0093)     ' Panel Interface control 3 (R93h)
  data($0103)      ' Page 38, SPFD5408B Datasheet 
  cmd($0095)     ' Panel Interface control 4 (R95h)
  'data($0210)      ' Page 38, SPFD5408B Datasheet
  data($0110) 
  cmd($0097)     ' Panel Interface Control 5 (R97h)
  data($0000)      ' Page 40, SPFD5408B Datasheet
  cmd($0098)     ' Panel Interface Control 6 (R98h)
  data($0000)      ' Page 41, SPFD5408B Datasheet

  cmd( $f0 )
  data( $5408 )
  cmd( $f3 )
  data($0010)
  cmd($f4)
  data($0011)
  cmd($f0)
  data($0000)
  
  ' write_command(0x0007)     ' Display Control (R07h)
  cmd( $07 )
  ' write_data(0x0173)      ' Page 16, SPFD5408B Datasheet
  data( $0173 )

  ' dira:=0
  