con
  _CLKMODE      = XTAL1 + PLL8X                        
  _XINFREQ      = 10_000_000

  ' Chip select pin / bitmask
  CS_     = 22
  CS_pin  = 1<<22
  ' Register select
  RS_     = 9
  RS_pin  = 1<<9
  ' Write
  WR_     = 21
  WR_pin  = 1<<21
  ' Read
  RD_     = 15
  RD_pin  = 1<<15
  ' Reset
  RES_    = 20
  RES_PIN = 1<<20

  SDpinBase = 16 

obj
  lcd: "SPFD5408driverC"
  sdfat: "fsrw_24"

var
  long bigBuffer1[4096] '2048]
  'long bigBuffer2[2048]
      
  long route, evenodd
  word pAdr[20]
  
pub main | ferb, xy, x ,y
  ' init the SD card driver
  x:=0
  pAdr[x++]:=string("orsi.bmp")
  pAdr[x++]:=string("ballon.bmp")
  ' pAdr[1]:=0
  pAdr[x++]:=string("woman.bmp")
  pAdr[x++]:=string("ballet.bmp")
  pAdr[x++]:=string("bole.bmp")
  pAdr[5]:=string("eye.bmp")
  pAdr[x++]:=string("ole.bmp")
  pAdr[x++]:=string("palm.bmp")
  pAdr[x++]:=string("pumkin.bmp")
  pAdr[x++]:=string("home.bmp")
  pAdr[x++]:=string("ring.bmp")
  pAdr[x++]:=string("svet.bmp")
  pAdr[x++]:=string("springer.bmp")
  pAdr[x++]:=string("red.bmp")
  pAdr[x++]:=string("psst.bmp")
  pAdr[x++]:=string("pink.bmp")
  pAdr[x++]:=string("bee.bmp")
  pAdr[x++]:=0
  

  lcd.start( RS_, CS_, RD_, WR_, RES_ )

  Init
  
  dira[24]:=1
  outa[24]:=1

  ' Color cycle
  ferb:=0
  repeat
    PicLoop

pub PicLoop | i
  i:=0
  repeat while pAdr[i]
    PrintPic( pAdr[i++], 230400, $000ef )
    waitcnt( clkfreq*5+cnt )
    
pub PrintPic( fname, size, pos ) | c, col, pix, rd
  sdfat.mount( SDpinBase )
  sdfat.popen(fname, "r")
  sdfat.pread(@bigBuffer1, 54)

  lcd.exec1( lcd#CMD_HOME, pos )

  rd:=size
  repeat while rd>0
    sdfat.pread(@bigBuffer1, 4096*4)
    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#4096)) '1024) )
    rd := rd - 4096*4
    'if rd>0
     '' sdfat.pread(@bigBuffer2, 4096*2)
      'lcd.exec( lcd#CMD_COPY, (@bigBuffer2)<<16 + ((rd/4)<#2048)) '1024) )
      'rd := rd - 4096*2
    '**** old code
    'repeat c from 0 to 4094 step 3
    '  rd += 3
    '  if rd<230400
    '    pix := byte[@bigBuffer+c]<<16+byte[@bigBuffer+c+1]<<8+byte[@bigBuffer+c+2]
    '    lcd.exec( lcd#CMD_PIXELOUT, pix )
     
  sdfat.pclose

pub TestPin( pinNo )
  dira:=1<<pinNo
  repeat
    outa[pinNo]~
    outa[pinNo]~~


pub PrintChar( x, y, col, char ) | startBit, pixels, adr, xo, yo
  adr := $8000 + char*32

  startBit := 1<<(30 + (char & $1))
  repeat yo from 0 to 31
    pixels := long[ $8000 + (char&$fe)<<6 + yo*4]
    repeat xo from 0 to 15
      if pixels & startBit
        Plot( 239-(x-xo), y-yo, col )
      pixels := pixels<<2 
      
pub Plot( x, y, col )
  'cmd( $2000 )
  'data( x<<8 )
  'cmd( $2100 )
  'data( (y&$ff)<<8 + (y>>8)&$ff )
  'cmd( $2200 )
  lcd.exec1( lcd#CMD_HOME, y<<8+x )
  lcd.exec1( lcd#CMD_PIXELOUT, col )
  
pub Home
  lcd.exec1( lcd#CMD_HOME, $000ef )
  'cmd( $2000 )
  'data( $ef00 )

  'cmd( $2100 )
  'data( 0 )

  'cmd( $2200 )

pri cmd( command ) | col
  lcd.exec1( lcd#CMD_CMDOUT, command )
  waitcnt( 500+cnt )

pri data( val ) | col
  lcd.exec1( lcd#CMD_DATAOUT, val )
  ' waitcnt( 500+cnt )

pri pixel( col )
  lcd.exec1( lcd#CMD_PIXELOUT, col )

dat
  word
initSeq
  word $000c, $0005, $0005, $0005, $0002, $0001, $0028, $0000

initData
  word $0000, $0100
  word $0100, $0000
  word $0200, $0107
  word $0300, $20C0
  word $0400, $0000
  word $0800, $0702
  word $0900, $0000
  word $0a00, $0000
  word $0c00, $0000
  word $0d00, $0000
  word $0f00, $0000
  word $0700, $0101

  word $1000, $B010
  word $1100, $0700
  word $0700, $0100
  word $1200, $3B01
  word $1300, $000B

  word $2900, $1200
  word $2A00, $9500

  word $3000, $0a00         
  word $3100, $2613                                            
  word $3200, $290A                                            
  word $3300, $0A29                                            
  word $3400, $1326                                            
  word $3500, $0A0A                                            
  word $3600, $031E                                            
  word $3700, $1E03                                           
  word $3800, $0607                                            
  word $3900, $0303                                            
  word $3A00, $040E                                            
  word $3B00, $010E                                            
  word $3C00, $0E01                                            
  word $3D00, $0E04                                            
  word $3E00, $0303                                            
  word $3F00, $0706                                            
  word $5000, $0000
  word $5100, $EF00
  word $5200, $0000
  word $5300, $3F01
  word $6000, $0027
  word $6100, $0300
  word $6A00, $0000
  word $8000, $0000
  word $8100, $0000
  word $8200, $0000
  word $8300, $0000                                           
  word $8400, $0000                                           
  word $8500, $0000                                           
  word $9000, $1300
  word $9200, $0000                                           
  word $9300, $0301                                           
  word $9500, $1001       
  word $9700, $0000
  word $9800, $0000
  word $f000, $0854
  word $f300, $1000
  word $f400, $1100
  word $f000, $0000
  word $0700, $7301


pub Init | ptr1, ptr2, cont
  ptr1:=0
  ptr2:=0
  cont:=1

  repeat while cont==1
    repeat initSeq[ptr1]
      cmd( initData[ptr2++] )
      data( initData[ptr2++] )

    ptr1++

    if initSeq[ ptr1 ] == 0
      cont:=0
    else
      waitcnt(clkfreq/initSeq[ptr1] + cnt)
       
    ptr1++

  waitcnt(clkfreq/10+cnt)
  
  ' dira:=0