con
  _CLKMODE      = XTAL1 + PLL8X                        
  _XINFREQ      = 10_000_000

  ' Chip select pin / bitmask
  CS_     = 18
  CS_pin  = 1<<18
  ' Register select
  RS_     = 9
  RS_pin  = 1<<9
  ' Write
  WR_     = 17
  WR_pin  = 1<<17
  ' Read
  RD_     = 15
  RD_pin  = 1<<15
  ' Reset
  RES_    = 16
  RES_PIN = 1<<16

  SDpinBase = 24

  BUF_SIZE = 2048
  
  BMP_BASE = $0000_0000 
  KeyPinBase      = 10

  
obj
  lcd: "SPFD5408driverC"
  sdfat: "fsrwB"
  font: "Font8x12"
   kb: "keyboard"

var
  long bigBuffer1[BUF_SIZE]
  'long bigBuffer2[BUF_SIZE]

  long route, evenodd
'  word pAdr[30]
  long startT, endT, correctT, combuf, bmpfound
  byte flname[13]
  
pub main | ferb, xy, x ,y, mask, key
  kb.start(KeyPinBase+1,KeyPinBase)

  key := kb.getKey
  key := key-$30
  
  ' init the SD card driver
  x:=0
  
  startT:=cnt
  endT:=cnt
  correctT:=endT-startT
  
  mask:=lcd.start( RS_, CS_, RD_, WR_, RES_ )
  Init
  ' Clearscreen
  lcd.exec1( lcd#CMD_HOME, $00ef )
  lcd.exec1( lcd#CMD_CLEAR, 0 )

  sdfat.mount( SDpinBase, lcd.getCmdBuf, mask )
  'combuf := sdfat.getComBuf

  ' Scan the directory for .bmp files
  startT:=cnt
  sdfat.opendir
  bmpfound:=0
  repeat until sdfat.nextfile( @flname )
    y:=0
    repeat until flname[y++] == "." or y==13
    if flname[y]=="B" and flname[y+1]=="M" and flname[y+2]=="P"   
      sdfat.vwMemCmpCopy( BMP_BASE + bmpfound<<4, @flname, 13 )
      bmpfound++
  sdfat.vMemFlush
  endT:=cnt
  PrintMs
  wait( key )

  ' read some data from SD using the SD-LCD link
  x:=sdfat.getSwap
  startT:=cnt
  lcd.exec1( lcd#CMD_HOME, $000ef )
  lcd.exec1( lcd#CMD_CMDOUT, $2200 )
  repeat y from 0 to 449
    sdfat.checkSektor( $1000000 + y<<9 )
    lcd.exec1( lcd#CMD_COPY, x<<16 + 128) '1024) )    
  endT:=cnt
  PrintMs
  wait( key )


  
  ' Color cycle
  ferb:=0
  route:= %1111111111
  repeat
    ' Menu
    printIt := 0
    PrintPic( string("Menu_bck.bmp"), 230400, $000ef )
    printIt := 1
    'lcd.exec2( lcd#CMD_SETWIN, $00d70010, $00300000 )
    'lcd.exec1( lcd#CMD_HOME, $10<<8 + $d7 )
    'lcd.exec1( lcd#CMD_CMDOUT, $2200 )
    'sdfat.copyblock( $4000>>9+520, 38 )
    'lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )
    startT:=cnt
    PrintMenuEntry( 0, 20, 50 )
    PrintMenuEntry( 1, 20, 100 )
    PrintMenuEntry( 2, 20, 150 )
    PrintMenuEntry( 3, 20, 200 )
    endT:=cnt
    PrintMs
    wait( key )
     
    x := sdfat.popen( string("womanrip.bmp"), "r" )
    startT:=cnt
    lcd.exec1( lcd#CMD_HOME, $000ef )
    lcd.exec1( lcd#CMD_CMDOUT, $2200 )
    'repeat y from 0 to 449
    '  sdfat.copyblock( x+y, 1 )
    sdfat.copyblock( x, 450 )
    endT:=cnt
    PrintMs
    wait( key )
     
    
    if route & %100000000
      repeat evenodd from 0 to 15
        lcd.setCol( evenodd, $000010 * evenodd )'  + $100000 * (15-evenodd) )
      lcd.exec1( lcd#CMD_CPYCOLTAB, 15 )

      xy:=0

      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff

      repeat 30
        bigBuffer1[xy++] := $ffeeddcc
        bigBuffer1[xy++] := $bbaa9988
        bigBuffer1[xy++] := $77665544
        bigBuffer1[xy++] := $3322110f
        
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff

      repeat xy from 0 to 31
        SetBufPix( xy, xy, 8 )

      startT:=cnt
      repeat y from 0 to 200 step 32
        repeat x from 0 to 200 step 32
          Icon( x, y, 32, 32, @bigBuffer1 )  
      endT:=cnt
      PrintMs
      wait( key )

    Scroll


    if route & %1000000000
      OwnFont( 10,50,string("ABCBABACC") )
      wait( key )
      
    if route & %1
      lcd.exec1( lcd#CMD_CMDOUT, $0300 )
      lcd.exec1( lcd#CMD_DATAOUT, $2040 )
      x := sdfat.popen( string("psst.img"), "r" )
      startT:=cnt
      lcd.exec1( lcd#CMD_HOME, $000ef )
      lcd.exec1( lcd#CMD_CMDOUT, $2200 )
      'repeat y from 0 to 449
      '  sdfat.copyblock( x+y, 1 )
      sdfat.copyblock( x, 300 )
      endT:=cnt
      PrintMs
      wait( key )
       
      LowColPic(string("springer.img"))
      LowColPic(string("bee.img"))
      LowColPic(string("ring.img"))
      LowColPic(string("home.img"))
      LowColPic(string("pink.img"))
      LowColPic(string("psst.img"))

    if route & %10
      LowRainbow(0)
      rainbow(0)
      waitcnt( clkfreq*5+cnt )
      LowRainbow(1)
      rainbow(1)
      'LowRainbow(2)
      'rainbow(2)
      wait( key )

    if route & %100
      PicLoop
      wait( key )

    if route & %1000
      MiniPic
      wait( key )

    if route & %10000
      startT := cnt
      repeat 30
        lcd.exec1( lcd#CMD_HOME, $00ef )
        lcd.exec1( lcd#CMD_CLEAR, ferb )
        ferb:=(ferb+$2f1a0c)
      endT := cnt
      PrintMs
      wait( key )
     
    if route & %100000
      repeat xy from 0 to 239
        Plot( xy, xy, $ffffff )
        Plot( 239-xy, xy, $ffffff )

    if route & %1000000
      repeat evenodd from 0 to 15
        lcd.setCol( evenodd, $000010 * evenodd )
      lcd.exec1( lcd#CMD_CPYCOLTAB, 15 )
      repeat xy from 0 to 312 step 3
        lcd.exec1( lcd#CMD_ACTCOL, xy/3 )
        lcd.exec2( lcd#CMD_LINE, (xy<<8)+ 10, ((312-xy)<<8)+230 )
      repeat evenodd from 0 to 15
        lcd.setCol( evenodd, $100000 * evenodd )
      lcd.exec1( lcd#CMD_CPYCOLTAB, 15 )
      repeat xy from 0 to 237 step 3
        lcd.exec1( lcd#CMD_ACTCOL, xy/3 )
        lcd.exec2( lcd#CMD_LINE, xy, 312<<8+237-xy )
      wait( key )
       
    if route & %10000000
      repeat xy from 0 to 149
        x:=xy//15
        y:=xy/15
        PrintChar( x*16,100+y*32, $ffff00+y*25, xy )
       
      wait( key )

    ' lcd.exec1( lcd#CMD_HOME, $00ef )
    ' lcd.exec1( lcd#CMD_CMDOUT, $2200 )
    ' startT := cnt
    ' lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + BUF_SIZE )
    ' lcd.exec1( lcd#CMD_HOME, $00ef )
    ' endT := cnt

    ' lcd.exec1( lcd#CMD_HOME, $00ef )
    ' lcd.exec1( lcd#CMD_CLEAR, ferb )

    ' PrintMS

    ' waitcnt( clkfreq*5+cnt )

pub wait( forwhat ) | key
  if forwhat == 0
    waitcnt( clkfreq*5+cnt )

  if forwhat == 1
    key := kb.getKey


pub PrintMenuEntry( men, x, y )
  lcd.exec2( lcd#CMD_SETWIN, (x+199)<<16+x, (320-y-1)<<16 + (320-y-32) )
  lcd.exec1( lcd#CMD_HOME, (320-y-32)<<8 + x+200 )
  lcd.exec1( lcd#CMD_CMDOUT, $2200 )
  sdfat.copyblock( $4000>>9+men*38+520, 38 )
  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )

pub Scroll | y
  repeat y from 0 to 319
    lcd.exec1( lcd#CMD_CMDOUT, $6a00)
    lcd.exec1( lcd#CMD_DATAOUT, 1 )
    'lcd.exec1( lcd#CMD_HOME, $000ef )
    lcd.exec1( lcd#CMD_CMDOUT, $2200 )
    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + 180) '1024) )
    
    waitcnt( clkfreq/100+cnt )

  lcd.exec1( lcd#CMD_CMDOUT, $6a00)
  lcd.exec1( lcd#CMD_DATAOUT, 0 )

pub OwnFont(x,y,str) | cp, cAdr, line, scan, pixOut
  cp := 0
  repeat while byte[str][cp]
    cAdr := font.getChar( byte[str][cp++] )
     
    repeat line from 0 to 11
      scan := word[cAdr][line]
      repeat pixOut from 0 to 7
        lcd.exec1( lcd#CMD_HOME, (y-line)<<8+ 240-(x+pixOut+(cp*10)) )
        lcd.exec1( lcd#CMD_CMDOUT, $2200 )
        'lcd.exec1( lcd#CMD_PIXELOUT, $ffffff )
        case (scan & %1100000000000000)
          %0000000000000000:
            lcd.exec1( lcd#CMD_PIXELOUT, $3333ff )
          %0100000000000000:
            lcd.exec1( lcd#CMD_PIXELOUT, $00cccc )
          %1000000000000000:
            lcd.exec1( lcd#CMD_PIXELOUT, $aa00aa )
          %1100000000000000:
            lcd.exec1( lcd#CMD_PIXELOUT, $aaFFFF )
        scan:=scan<<2
            
  
pub Icon(x,y,b,h, buffer)
  lcd.exec2( lcd#CMD_SETWIN, ((x+b-1)<<16)+x, ((y+h-1)<<16)+y )
  lcd.exec1( lcd#CMD_HOME, y<<8+x+b-1 )
  lcd.exec1( lcd#CMD_COPY16, (buffer << 16) + b*h/8 )
  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )

pub SetBufPix(x,y,col)
  bigBuffer1[y*4+(x>>3)//4] := bigBuffer1[y*4+(x>>3)//4] & !($f0000000>>((x&7) *4)) | (col&15)<<((7-(x&7))*4)
  
pub rainbow(k) | i, j, r, g, b
  'lcd.exec1( lcd#CMD_HOME, $36000 )
  Home

  repeat i from 0 to 319
    repeat j from 0 to 239
      if k==0
        r:=j*106/100 ' & $ff
        g:=i*100/125
        b:=0' ((255-r+255-g)& $1ff)>>1
      if k==1
        r:=j*106/100 ' & $ff
        g:=0
        b:=i*100/125
      if k==2
        r:=i*100/125 ' & $ff
        g:=i*100/125
        b:=i*100/125
      
      lcd.exec1( lcd#CMD_PIXELOUT, b +g<<8+r<<16 )
    
pub LowRainbow(k) | i, j, r, g, b
  lcd.exec1( lcd#CMD_CMDOUT, $0300 )
  lcd.exec1( lcd#CMD_DATAOUT, $2040 )
  'lcd.exec1( lcd#CMD_HOME, $36000 )
  Home

  repeat i from 0 to 319
    repeat j from 0 to 239
      if k==0
        r:=j/10
        b:=0
        g:=i/5 'j*100/375
      if k==1
        r:=j/10
        b:=i/10
        g:=0
      if k==2
        r:=i/10
        b:=i/10
        g:=i/5
      lcd.exec1( lcd#CMD_DATAOUT, b<<3 + (g&56)>>3 + (g&7)<<13 + r<<8 )

  lcd.exec1( lcd#CMD_CMDOUT, $0300 )
  lcd.exec1( lcd#CMD_DATAOUT, $20C0 )
  waitcnt( clkfreq*5+cnt )
    
pub LowColPic(fname) | rd, sektor, i
  lcd.exec1( lcd#CMD_CMDOUT, $0300 )
  lcd.exec1( lcd#CMD_DATAOUT, $2040 )

  ' sdfat.mount( SDpinBase )
  sektor := sdfat.popen(fname, "r")
  ' sdfat.pread(@bigBuffer, 54)

  lcd.exec1( lcd#CMD_HOME, $000ef )

  rd:=153604
  startT := cnt
  i:=0
  repeat while rd>0
    'sdfat.pread(@bigBuffer1, constant(BUF_SIZE*4))
    'lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#BUF_SIZE))
    'rd := rd - constant( BUF_SIZE*4 )
    sdfat.readblock( sektor+i++, @bigBuffer1)
    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#128)) '512))
    rd := rd - constant( 512 )'*4 )

  endT := cnt

  PrintMs
     
  sdfat.pclose
    
  lcd.exec1( lcd#CMD_CMDOUT, $0300 )
  lcd.exec1( lcd#CMD_DATAOUT, $20C0 )
  waitcnt( clkfreq*5+cnt )

pub MiniPic
  lcd.exec2( lcd#CMD_SETWIN, $008f0010, $00900010 )
  printItAnyway:=1
  PrintPic( string("orange.bmp"),49152, $10<<8+$8f )
  waitcnt( clkfreq*5+cnt )
  PrintPic( string("eye2.bmp"),49152, $10<<8+$8f )
  waitcnt( clkfreq*5+cnt )
  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )
  printItAnyway:=0

pub PicLoop | i
  i:=0
  repeat i from 0 to bmpfound-1
    sdfat.vrMemCopy( BMP_BASE + i<<4, @flname, 13 )
    if PrintPic( @flname, 230400, $000ef )
      waitcnt( clkfreq*5+cnt )
    
pub PrintPic( fname, size, pos ) | c, col, pix, rd
  'sdfat.mount( SDpinBase )
  sdfat.popen(fname, "r")
  sdfat.pread(@bigBuffer1, 54)

  if not(printItAnyway) and not(byte[@bigBuffer1][18]==$f0 and byte[@bigBuffer1][22]==$40 and byte[@bigBuffer1][23]==$01)
    sdfat.pclose
    return 0

  lcd.exec1( lcd#CMD_HOME, pos )

  rd:=size
  startT := cnt
  repeat while rd>0
    sdfat.pread(@bigBuffer1, constant( BUF_SIZE*4) )
    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#BUF_SIZE))
    rd := rd - constant( BUF_SIZE*4 )
    'if rd>0
      'sdfat.pread(@bigBuffer2, constant( BUF_SIZE*4 ) )
      'lcd.exec1( lcd#CMD_COPY, (@bigBuffer2)<<16 + ((rd/4)<#BUF_SIZE))
      'rd := rd - constant( BUF_SIZE*4 )
  endT := cnt

  if printIt
    PrintMs
       
  sdfat.pclose
  return 1

pub PrintInt(x,y,val) | count, rest
  repeat while val>0
    rest := val//10 + $30
    val:=val/10
    PrintChar( x-count*16, y, $ffffff, rest )
    count++

pub PrintMs | count, rest, val
  val := ( endT - startT - correctT )/8000
  count := 0

  PrintChar( 210-count++*16, 50, $ffffff, "s" )
  PrintChar( 210-count++*16, 50, $ffffff, "m" )
   
  repeat while val>0
    rest := val//10 + $30
    val:=val/10
    PrintChar( 210-count*16, 50, $ffffff, rest )
    count++
    if count==3
      PrintChar( 210-count*16, 50, $ffffff, "," )
      count++

pub TestPin( pinNo )
  dira:=1<<pinNo
  repeat
    outa[pinNo]~
    outa[pinNo]~~


pub PrintChar( x, y, col, char ) | startBit, pixels, adr, xo, yo
  adr := $8000 + char*32

  startBit := 1<<(30 + (char & $1))
  repeat yo from 0 to 31
    pixels := long[ $8000 + (char&$fe)<<6 + yo*4]
    repeat xo from 0 to 15
      if pixels & startBit
        Plot( 239-(x-xo), y-yo, col )
      pixels := pixels<<2 
      
pub Plot( x, y, col )
  'cmd( $2000 )
  'data( x<<8 )
  'cmd( $2100 )
  'data( (y&$ff)<<8 + (y>>8)&$ff )
  'cmd( $2200 )
  lcd.exec1( lcd#CMD_HOME, y<<8+x )
  lcd.exec1( lcd#CMD_PIXELOUT, col )
  
pub Home
  lcd.exec1( lcd#CMD_HOME, $000ef )
  'cmd( $2000 )
  'data( $ef00 )

  'cmd( $2100 )
  'data( 0 )

  'cmd( $2200 )

pri cmd( command ) | col
  lcd.exec1( lcd#CMD_CMDOUT, command )
  waitcnt( 500+cnt )

pri data( val ) | col
  lcd.exec1( lcd#CMD_DATAOUT, val )
  ' waitcnt( 500+cnt )

pri pixel( col )
  lcd.exec1( lcd#CMD_PIXELOUT, col )

pub Init | col
  cmd( $00 )
  data( $0100 )
  cmd( $0100 )
  data( 0 )
  cmd( $0200 )
  data( $0107 )
  cmd( $0300 )
  data( $20C0 )
  cmd( $0400 )
  data( 0 )
  cmd( $0800 )
  data( $0702 )
  cmd( $0900 )
  data( 0 )
  cmd( $0a00 )
  data( 0 )
  cmd( $0c00 )
  data( 0 )
  cmd( $0d00 )
  data( 0 )
  cmd( $0f00 )
  data( 0 )
  cmd( $0700 )
  data( $0101 )

  waitcnt( clkfreq/5 +cnt )
  
  cmd( $1000 )
  data( $B010 )
  cmd( $1100 )
  data( $0700 )
  cmd( $0700 )
  data( $0100 )
  cmd( $1200 )
  data( $3B01 )
  cmd( $1300 )
  data( $000B )

  waitcnt( clkfreq/5 +cnt )

  cmd( $2900 )
  data( $1200 )
  cmd( $2A00 )
  data( $9500 )

  waitcnt( clkfreq/50 + cnt )

  cmd( $3000 )
  data( $0a00 ) 
  cmd($3100)     ' Gamma Control 2
  data($2613)      ' Page 32, SPFD5408B Datasheet  
  cmd($3200)     ' Gamma Control 3
  data($290A)      ' Page 32, SPFD5408B Datasheet  
  cmd($3300)     ' Gamma Control 4
  data($0A29)      ' Page 32, SPFD5408B Datasheet  
  cmd($3400)     ' Gamma Control 5
  data($1326)      ' Page 32, SPFD5408B Datasheet  
  cmd($3500)     ' Gamma Control 6
  data($0A0A)      ' Page 32, SPFD5408B Datasheet  
  cmd($3600)     ' Gamma Control 7
  data($031E)      ' Page 32, SPFD5408B Datasheet  
  cmd($3700)     ' Gamma Control 8
  data($1E03)      ' Page 32, SPFD5408B Datasheet 
  cmd($3800)     ' Gamma Control 9
  data($0607)      ' Page 32, SPFD5408B Datasheet  
  cmd($3900)     ' Gamma Control 10
  data($0303)      ' Page 32, SPFD5408B Datasheet  
  cmd($3A00)     ' Gamma Control 11
  data($040E)      ' Page 32, SPFD5408B Datasheet  
  cmd($3B00)     ' Gamma Control 12
  data($010E)      ' Page 32, SPFD5408B Datasheet  
  cmd($3C00)     ' Gamma Control 13
  data($0E01)      ' Page 32, SPFD5408B Datasheet  
  cmd($3D00)     ' Gamma Control 14
  data($0E04)      ' Page 32, SPFD5408B Datasheet  
  cmd($3E00)     ' Gamma Control 15
  data($0303)      ' Page 32, SPFD5408B Datasheet  
  cmd($3F00)     ' Gamma Control 16
  data($0706)      ' Page 32, SPFD5408B Datasheet  

  ' the data calls that are commented out came from demo-code, the actual
  ' calls use parameters as given in init-sequence of datasheet
  cmd($5000)     ' Window Horizontal RAM Address Start (R50h)
  data($0000)      ' Page 32, SPFD5408B Datasheet
  cmd($5100)     ' Window Horizontal RAM Address End (R51h)
  data($EF00)      ' Page 32, SPFD5408B Datasheet
  cmd($5200)     ' Window Vertical RAM Address Start (R52h)
  data($0000)      ' Page 33, SPFD5408B Datasheet
  cmd($5300)     ' Window Vertical RAM Address End (R53h)
  data($3F01)      ' Page 33, SPFD5408B Datasheet

  cmd($6000)     ' Driver Output Control (R60h)
  data($0027)      ' Page 33, SPFD5408B Datasheet
  cmd($6100)     ' Driver Output Control (R61h)
  data($0100)      ' Page 35, SPFD5408B Datasheet

  cmd($6A00)     ' Vertical Scroll Control (R6Ah)
  data($0000)      ' Page 35, SPFD5408B Datasheet

  cmd($8000)     ' Display Position - Partial Display 1 (R80h)
  data($0000)      ' Page 35, SPFD5408B Datasheet
  cmd($8100)     ' RAM Address Start - Partial Display 1 (R81h)
  data($0000)      ' Page 35, SPFD5408B Datasheet
  cmd($8200)     ' RAM Address End - Partial Display 1 (R82h)
  data($0000)      ' Page 36, SPFD5408B Datasheet
  cmd($8300)     ' Display Position - Partial Display 2 (R83h)
  data($0000)      ' Page 36, SPFD5408B Datasheet 
  cmd($8400)     ' RAM Address Start - Partial Display 2 (R84h)
  data($0000)      ' Page 36, SPFD5408B Datasheet 
  cmd($8500)     ' RAM Address End - Partial Display 2 (R85h)
  data($0000)      ' Page 36, SPFD5408B Datasheet 

  cmd($9000)     ' Panel Interface Control 1 (R90h)
  data($1300)
  cmd($9200)     ' Panel Interface Control 2 (R92h)
  data($0000)      ' Page 37, SPFD5408B Datasheet 
  cmd($9300)     ' Panel Interface control 3 (R93h)
  data($0301)      ' Page 38, SPFD5408B Datasheet 
  cmd($9500)     ' Panel Interface control 4 (R95h)
  data($1001) 
  cmd($9700)     ' Panel Interface Control 5 (R97h)
  data($0000)      ' Page 40, SPFD5408B Datasheet
  cmd($9800)     ' Panel Interface Control 6 (R98h)
  data($0000)      ' Page 41, SPFD5408B Datasheet

  cmd( $f000 )
  data( $0854 )
  cmd( $f300 )
  data($1000)
  cmd($f400)
  data($1100)
  cmd($f000)
  data($0000)
  
  cmd( $0700 )
  data( $7301 )

  ' dira:=0

dat
zahl long $1234_5678
printIt long 1
printItAnyway long 0