con
  _CLKMODE      = XTAL1 + PLL8X                        
  _XINFREQ      = 10_000_000

  ' Chip select pin / bitmask
  CS_     = 22
  CS_pin  = 1<<22
  ' Register select
  RS_     = 9
  RS_pin  = 1<<9
  ' Write
  WR_     = 21
  WR_pin  = 1<<21
  ' Read
  RD_     = 15
  RD_pin  = 1<<15
  ' Reset
  RES_    = 20
  RES_PIN = 1<<20

  TVPinBase = 12
  BUF_SIZE  = 2048

   sd_DO = 16
   sd_CLK = 19
   sd_DI = 18
   sd_CS = 17

obj
  tv:    "TV_Text"
  sdfat: "fsrw_24"
  lcd:   "SPFD5408driverC"

var
  long bigBuffer1[BUF_SIZE]
  word pAdr[40]

pub main | x, i
  tv.start( TVPinBase )
  tv.str( string("FSRW 2.4 test",$0d) )

  x:=0
  pAdr[x++]:=string("orsi.bmp")
  pAdr[x++]:=string("ballon.bmp")
  pAdr[x++]:=string("woman.bmp")
  pAdr[x++]:=string("ballet.bmp")
  pAdr[x++]:=string("bole.bmp")
  pAdr[x++]:=string("ole.bmp")
  pAdr[x++]:=string("palm.bmp")
  pAdr[x++]:=string("pumkin.bmp")
  pAdr[x++]:=string("home.bmp")
  pAdr[x++]:=string("ring.bmp")
  pAdr[x++]:=string("springer.bmp")
  pAdr[x++]:=string("red.bmp")
  pAdr[x++]:=string("psst.bmp")
  pAdr[x++]:=string("pink.bmp")
  pAdr[x++]:=string("bee.bmp")
  pAdr[x++]:=0

  pAdr[ x++ ]:=string("bar_01.bm")
  pAdr[ x++ ]:=string("bar_02.bm")
  pAdr[ x++ ]:=string("bar_03.bm")
  pAdr[ x++ ]:=string("bar_04.bm")
  pAdr[ x++ ]:=string("bar_05.bm")
  pAdr[ x++ ]:=string("bar_06.bm")
  pAdr[ x++ ]:=string("bar_07.bm")
  pAdr[ x++ ]:=string("bar_08.bm")
  pAdr[ x++ ]:=string("bar_09.bm")
  pAdr[ x++ ]:=string("bar_10.bm")
  pAdr[ x++ ]:=string("bar_11.bm")
  pAdr[ x++ ]:=string("bar_12.bm")
  pAdr[x++]:=0
    

  i:=lcd.start( RS_, CS_, RD_, WR_, RES_ )
  dira[ 24 ] := 1
  outa[ 24 ] := 1
  
  lcd.Init
  ' Clearscreen
  lcd.exec1( lcd#CMD_HOME, $00ef )
  lcd.exec1( lcd#CMD_CLEAR, $ff0000 )

  repeat 
    PicLoop

    PrintPic( string("SHCback.bm") )
    waitcnt( clkfreq*5+cnt )
    ScrollIconBar(203, 45)

pub ScrollIconBar( x, y )  | f, rd, i, sektor
  lcd.exec2( lcd#CMD_SETWIN, $00ef00c0, $010e000a )
  repeat f from 16 to 27
    PrintPic2( pAdr[ f ],37584, $0a<<8+$ef )
  ' waitcnt( clkfreq*5 + cnt )
  repeat f from 27 to 16
    PrintPic2( pAdr[ f ],37584, $0a<<8+$ef )

  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )
  lcd.exec1( lcd#CMD_HOME, $00ef )
  PrintPic( string("SHCback.bm") )

pub PicLoop | i
  i:=0
  repeat while pAdr[i]
    PrintPic( pAdr[i++] )
    'waitcnt( clkfreq*5+cnt )

pub PrintPic2( fname, size, pos ) | c, col, pix, rd
  sdfat.mount_explicit(sd_DO, sd_CLK, sd_DI, sd_CS)

  sdfat.popen(fname, "r")
  sdfat.pread(@bigBuffer1, 54)

  lcd.exec1( lcd#CMD_HOME, pos )

  rd:=size
  repeat while rd>0
    sdfat.pread(@bigBuffer1, constant( BUF_SIZE*4) )
    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#BUF_SIZE))
    rd := rd - constant( BUF_SIZE*4 )
       
  sdfat.pclose

pub PrintPic( fname ) | rd, i, tstart, tend

  sdfat.mount_explicit(sd_DO, sd_CLK, sd_DI, sd_CS)
  tstart := cnt
  sdfat.popen(fname,"r")
  sdfat.pread(@bigBuffer1, 54)
   
  rd:=230400
  i:=0
  repeat while rd>0
    sdfat.pread(@bigBuffer1, constant(BUF_SIZE<<2))
    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#BUF_SIZE))
    rd := rd - constant( BUF_SIZE<<2 )

  sdfat.pclose
  tend:=cnt

  tv.dec( tend-tstart )
  tv.out( $0d )
  